unit Empresa;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, FMX.StdCtrls,
  System.Variants, FMX.Forms, FMX.Dialogs, System.Math, FMX.TMSTableView, FMX.Graphics, FMX.Surfaces,
  FMX.Edit, FMX.Types, FMX.TMSBaseControl, FMX.TMSBitmap, FMX.Platform,
  FMX.Objects, FMX.Controls, FMX.Controls.Presentation, FMX.TMSCustomEdit,
  FMX.TMSEdit, FMX.TMSBaseGroup, Data.DB, FMX.VirtualKeyboard,
  FMX.Layouts, FMX.TMSTaskDialog,
  FMX.TMSBitmapContainer, FMX.TMSButton, FMX.TabControl, System.Permissions, DW.ShareItems, DW.Consts.Android, DW.Permissions.Helpers,
  FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Param,
  FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf, FireDAC.DApt.Intf,
  FireDAC.Stan.Async, FireDAC.DApt, FireDAC.Comp.DataSet, FireDAC.Comp.Client;

type
  TEmpresaF = class(TForm)
    PanelTituloForma: TRectangle;
    EtiquetaSubPanelTituloForma: TLabel;
    GrupoBotonAnterior: TLayout;
    BotonAnterior: TTMSFMXImage;
    GrupoBotonSiguiente: TLayout;
    BotonSiguiente: TTMSFMXImage;
    StyleBook1: TStyleBook;
    TablaEmpresa: TTMSFMXTableView;
    ListaRegimenesFiscales: TTMSFMXTableView;
    Descripcion: TTMSFMXEdit;
    ListaEstados: TTMSFMXTableView;
    ListaGeneros: TTMSFMXTableView;
    ContenedorImagenes: TTMSFMXBitmapContainer;
    PaginadorDatos: TTabControl;
    EditaEmpresa: TTabItem;
    EditaLogotipo: TTabItem;
    FotoTomada: TTMSFMXImage;
    GrupoBotonFotoLogotipo: TLayout;
    BotonFotoLogotipo: TTMSFMXImage;
    ListaUsuarios: TTMSFMXTableView;
    GrupoEliminaFotoLogotipo: TLayout;
    BotonEliminarFotoLogotipo: TTMSFMXImage;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TablaPreciosCategoryCustomize(Sender: TObject;
      ACategoryShape: TTMSFMXTableViewCategoryShape);
    procedure TablaPreciosItemClick(Sender: TObject;
      AItem: TTMSFMXTableViewItem);
    procedure TablaEmpresaItemClick(Sender: TObject; AItem: TTMSFMXTableViewItem);
    procedure DescripcionChange(Sender: TObject);
    procedure TablaEmpresaItemCustomize(Sender: TObject; AItem: TTMSFMXTableViewItem;
      AItemShape: TTMSFMXTableViewItemShape; AItemControlShape: TControl);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ListaUsuariosCategoryCustomize(Sender: TObject;
      ACategoryShape: TTMSFMXTableViewCategoryShape);
    procedure ListaUsuariosItemClick(Sender: TObject;
      AItem: TTMSFMXTableViewItem);
    procedure ListaUsuariosItemCustomize(Sender: TObject;
      AItem: TTMSFMXTableViewItem; AItemShape: TTMSFMXTableViewItemShape;
      AItemControlShape: TControl);
  private
    { Private declarations }
    procedure SelectorCompleteHandler(Sender: TObject; const AOK: Boolean);
  public
    { Public declarations }
  end;

var
  EmpresaF: TEmpresaF;

implementation

{$R *.fmx}

procedure TEmpresaF.SelectorCompleteHandler(Sender: TObject; const AOK: Boolean);
begin
end;

procedure TEmpresaF.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Action := TCloseAction.caFree;
end;

procedure TEmpresaF.FormCreate(Sender: TObject);
begin
     // Hacemos el control mas grande
     Descripcion.StyledSettings := [];
     Descripcion.Font.Size := 20;
     Descripcion.Height := 200;
end;

procedure TEmpresaF.TablaEmpresaItemClick(Sender: TObject;
  AItem: TTMSFMXTableViewItem);
begin
     Case AItem.Tag of
          // Campo descripcin
          0:
          Begin
               GrupoBotonSiguiente.Visible := False;
               GrupoBotonFotoLogotipo.Visible := False;
               GrupoEliminaFotoLogotipo.Visible := False;
               ListaEstados.Visible := False;
               ListaRegimenesFiscales.Visible := False;
               ListaUsuarios.Visible := False;
               Descripcion.Tag := 1;
               Descripcion.Text := AItem.Description;
               Descripcion.Tag := 0;
               Descripcion.SetFocus;
          End;
          // Campo numrico
          1:
          Begin
               Descripcion.Visible := False;
               GrupoBotonSiguiente.Visible := False;
               GrupoBotonFotoLogotipo.Visible := False;
               GrupoEliminaFotoLogotipo.Visible := False;
               ListaEstados.Visible := False;
               ListaRegimenesFiscales.Visible := False;
               ListaUsuarios.Visible := False;
          End;
          // Estados
          2:
          Begin
               Descripcion.Visible := False;
               GrupoBotonSiguiente.Visible := False;
               GrupoBotonFotoLogotipo.Visible := False;
               GrupoEliminaFotoLogotipo.Visible := False;
               ListaRegimenesFiscales.Visible := False;
               ListaUsuarios.Visible := False;
          End;
          // Rgimen fiscal
          3:
          Begin
               Descripcion.Visible := False;
               GrupoBotonSiguiente.Visible := False;
               GrupoBotonFotoLogotipo.Visible := False;
               GrupoEliminaFotoLogotipo.Visible := False;
               ListaEstados.Visible := False;
               ListaUsuarios.Visible := False;
          End;
          // Logotipo
          4:
          Begin
               GrupoBotonSiguiente.Visible := False;
               GrupoBotonFotoLogotipo.Visible := True;
               GrupoEliminaFotoLogotipo.Visible := True;
               ListaUsuarios.Visible := False;
               PaginadorDatos.ActiveTab := EditaLogotipo;
               EtiquetaSubPanelTituloForma.Text := 'Logotipo';
          End;
          // Visibilidad de Usuarios
          5:
          Begin
               GrupoBotonSiguiente.Visible := False;
               GrupoBotonFotoLogotipo.Visible := False;
               GrupoEliminaFotoLogotipo.Visible := False;
               EtiquetaSubPanelTituloForma.Text := 'Permisos de Acceso';
          End;
          // Crear Nueva Empresa
          19:
          Begin
               TablaEmpresa.BeginUpdate;
               TablaEmpresa.Items[0].Description := EmptyStr;
               TablaEmpresa.Items[1].Description := EmptyStr;
               TablaEmpresa.Items[2].Description := EmptyStr;
               TablaEmpresa.Items[3].Description := EmptyStr;
               TablaEmpresa.Items[4].Description := EmptyStr;
               TablaEmpresa.Items[5].Description := 'XAXX010101000';
               TablaEmpresa.Items[7].Description := EmptyStr;
               TablaEmpresa.Items[8].Description := EmptyStr;
               TablaEmpresa.Items[9].Description := EmptyStr;
               TablaEmpresa.Items[10].Description := EmptyStr;
               TablaEmpresa.Items[11].Description := EmptyStr;
               TablaEmpresa.Items[12].Description := EmptyStr;
               TablaEmpresa.Items[13].Description := EmptyStr;
               TablaEmpresa.Items[14].Description := '00000';

               // Establecemos el estado por default siempre y cuando no traiga el valor el Cliente
               TablaEmpresa.Items[16].Description := 'MXICO';
               TablaEmpresa.EndUpdate;
          End;
     End;
end;

procedure TEmpresaF.TablaEmpresaItemCustomize(Sender: TObject;
  AItem: TTMSFMXTableViewItem; AItemShape: TTMSFMXTableViewItemShape;
  AItemControlShape: TControl);
begin
     AItemShape.ShapeDescription.Font.Style := [TFontStyle.fsbold];
     AItemShape.DescriptionColor := TAlphaColorRec.Dodgerblue;
     AItemShape.DescriptionColorSelected := TAlphaColorRec.White;
     {$IF DEFINED(iOS) or DEFINED(ANDROID)}
          AItemShape.Stroke.Color := TAlphaColorRec.Darkgrey;
     {$ENDIF}

     // Pintamos los controles requeridos
     Case AItem.Index of
          0,1,4,5,6: AItemShape.ShapeCaption.Color := TAlphaColorRec.Red;
     End;
end;

procedure TEmpresaF.DescripcionChange(Sender: TObject);
begin
     If (Trim(Descripcion.Text) <> EmptyStr) and (Descripcion.Tag = 0) then
     Begin
          TablaEmpresa.SelectedItem.Description := UpperCase(Descripcion.Text);
          TablaEmpresa.SelectedItem.HideDetailView;
          GrupoBotonSiguiente.Visible := True;
     End;
end;

procedure TEmpresaF.FormDestroy(Sender: TObject);
begin
     // Cerramos la aplicacin
     EmpresaF := Nil;
end;

procedure TEmpresaF.ListaUsuariosCategoryCustomize(Sender: TObject;
  ACategoryShape: TTMSFMXTableViewCategoryShape);
begin
     // Ponemos el color de la categora en negro
     ACategoryShape.ShapeCaption.Color := TAlphaColorRec.Black;
end;

procedure TEmpresaF.ListaUsuariosItemClick(Sender: TObject;
  AItem: TTMSFMXTableViewItem);
begin
     // Indicamos el mtodo de pago seleccionado
     If AItem <> Nil then
     Begin
          ListaUsuarios.BeginUpdate;
          AItem.DataBoolean := Not AItem.DataBoolean;
          If AItem.DataBoolean then AItem.Description := 'S' Else AItem.Description := 'NO';
          ListaUsuarios.EndUpdate;
     End;
end;

procedure TEmpresaF.ListaUsuariosItemCustomize(Sender: TObject;
  AItem: TTMSFMXTableViewItem; AItemShape: TTMSFMXTableViewItemShape;
  AItemControlShape: TControl);
begin
     AItemShape.ShapeDescription.Font.Style := [TFontStyle.fsbold];
     AItemShape.DescriptionColor := TAlphaColorRec.Dodgerblue;
     AItemShape.DescriptionColorSelected := TAlphaColorRec.White;
     {$IF DEFINED(iOS) or DEFINED(ANDROID)}
          AItemShape.Stroke.Color := TAlphaColorRec.Darkgrey;
     {$ENDIF}

     // Pintamos los controles requeridos
     If AItem.DataBoolean then AItemShape.DescriptionColor := TAlphaColorRec.Green Else AItemShape.DescriptionColor := TAlphaColorRec.Red;
end;

procedure TEmpresaF.TablaPreciosCategoryCustomize(Sender: TObject;
  ACategoryShape: TTMSFMXTableViewCategoryShape);
begin
     // Ponemos el color de la categora en negro
     ACategoryShape.ShapeCaption.Color := TAlphaColorRec.Black;
end;

procedure TEmpresaF.TablaPreciosItemClick(Sender: TObject;
  AItem: TTMSFMXTableViewItem);
begin
     // Indicamos el mtodo de pago seleccionado
     if AItem <> Nil then
     Begin
          TablaEmpresa.SelectedItem.Description := AItem.Caption;
          TablaEmpresa.SelectedItem.TagFloat := AItem.TagFloat;
          TablaEmpresa.SelectedItem.TagString := AItem.TagString;
          TablaEmpresa.SelectedItem.HideDetailView;
          GrupoBotonSiguiente.Visible := True;
     End;
end;

end.

